<%@ Page Language="C#" MasterPageFile="~/WorkingArea.master" AutoEventWireup="true"
    CodeBehind="Alarms_Actions.aspx.cs" Inherits="Invensys.Compact.Presentation.Web.Settings.Alarms_Actions" %>

<%@ Register Src="~/UC/PageTitle.ascx" TagName="PageTitle" TagPrefix="ucPageTitle" %>
<%@ Register Src="~/UC/SubtabMenuSettingsAlarms.ascx" TagName="SubtabMenuSettingsAlarms"
    TagPrefix="ucSubtabMenuSettingsAlarms" %>
<%@ Register Src="~/UC/ToolBar.ascx" TagName="ToolBar" TagPrefix="ucToolBar" %>
<%@ Register Src="~/UC/GenericGrid.ascx" TagName="GenericGrid" TagPrefix="ucGenericGrid" %>
<%@ Register Src="~/UC/GenericContainer.ascx" TagName="GenericContainer" TagPrefix="ucGenericContainer" %>
<%@ Register Src="~/UC/GenericTextBox.ascx" TagName="GenericTextBox" TagPrefix="ucGenericTextBox" %>
<%@ Register Src="~/UC/GenericText.ascx" TagName="GenericText" TagPrefix="ucGenericText" %>
<%@ Register Src="~/UC/GenericLiteral.ascx" TagName="GenericLiteral" TagPrefix="ucGenericLiteral" %>
<%@ Register Src="~/UC/GenericDirectOutput.ascx" TagName="GenericDirectOutput" TagPrefix="ucGenericDirectOutput" %>
<%@ Register Src="~/UC/GenericCheckBox.ascx" TagName="GenericCheckBox" TagPrefix="ucGenericCheckBox" %>
<%@ Register Src="~/UC/GenericTextArea.ascx" TagName="GenericTextArea" TagPrefix="ucGenericTextArea" %>
<%@ Register Src="~/UC/GenericSelect.ascx" TagName="GenericSelect" TagPrefix="ucGenericSelect" %>
<%@ Register Src="~/UC/GeneralMessage.ascx" TagName="GeneralMessage" TagPrefix="ucGeneralMessage" %>
<%@ Register Src="~/UC/GenericClientServerConnector.ascx" TagName="GenericClientServerConnector"
    TagPrefix="ucGenericClientServerConnector" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ToolbarArea" runat="Server">
    <ucToolBar:ToolBar ID="ToolBar1" PageEditCommandsVisible="true" RecordEditCommandsVisible="true"
        runat="server" />
</asp:Content>
<asp:Content ID="ContentCSS" ContentPlaceHolderID="CssArea" runat="Server">
    <style type="text/css">
        table.wkaDataEntry td.wdeRecordDetail blockquote tr.inputcheckBox td input
        {
            font-family: Verdana, sans-serif;
            font-size: 12px;
            line-height: 20px;
            vertical-align: middle;
        }
        div.generalmessage.message p
        {
            padding-left: 45px;
            line-height: 24px;
            background: #FFFFD6 url(/media/img/Common/Messages/Info.gif) no-repeat 14px 4px;
            border: 1px solid #999AC6;
        }
    </style>
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="ContentArea" runat="Server">
    <asp:Literal ID="javascriptConstants" runat="server"></asp:Literal>

    <script language="JavaScript" type="text/JavaScript" src="/script/js/routerTestAction.js"></script>

    <script language="JavaScript" type="text/JavaScript">
        //<![CDATA[
        var manageArgs = true;
        var myClientDataEntry;
        var argsTextWidth = "80px";
        var ARGS_SEPARATOR = '|';
        var COMMAND_SEPARATOR = '#';
        var GROUP_SEPARATOR = '@';
        var ITEM_SEPARATOR = '$';
        
        function GetArguments(prefix) {
            var args = "";
            var i = 0;
            var currentControl = $(prefix + i);
            while (currentControl != null) {
                args += $(currentControl).value + ARGS_SEPARATOR;
                currentControl = $(prefix + ++i);
            }

            if (i > 0)
                args = args.substring(0, args.length - 1);

            return args;
        }

        function SetArguments(prefix, values) {
            for (i = 1; i < values.length; i++) {
                var currentControl = $(prefix + (i - 1));
                if (currentControl != null) {
                    $(currentControl).value = values[i];
                }
            }
        }

        function BuildArgs1() {
            BuildArgs('decCommand1', 'gArgs1', 'decArgA');
        }

        function BuildArgs2() {
            BuildArgs('decCommand2', 'gArgs2', 'decArgB');
        }

        function BuildBothArgs(ddlName) {
            if (manageArgs) {
                var ddlCommands = $(ddlName);
                if (ddlCommands.selectedIndex != -1) {
                    var selectedCommandID = ddlCommands.options[ddlCommands.selectedIndex].value;
                    var postBody = "modality=ajax" + "&exec=getArgumentsHTML" + "&commandID=" + selectedCommandID;
                    new Request({url:'/ActionCommandInvocation.rix', 
                                onComplete: function(request) {
                                    insertArguments(request, 'gArgs1', 'decArgA');
                                    insertArguments(request, 'gArgs2', 'decArgB');
                                },
                                timeout: 5000
                    }).send(postBody);
                }
            }
        }

        function BuildArgs(ddlName, target, prefix) {
            if (manageArgs) {
                var ddlCommands = $(ddlName);
                if (ddlCommands.selectedIndex != -1) {
                    var selectedCommandID = ddlCommands.options[ddlCommands.selectedIndex].value;
                    var postBody = "modality=ajax" + "&exec=getArgumentsHTML" + "&commandID=" + selectedCommandID;
                    new Request({url:'/ActionCommandInvocation.rix', 
                                onComplete: function(request) {
                                    insertArguments(request, target, prefix);
                                },
                                timeout: 5000
                    }).send(postBody);
                }
            }
        }

        function insertArguments(argumentList, target, prefix) {
            if (manageArgs) {
                var table = $(target);
                var argsArray = argumentList == "" ? new String() : argumentList.split(ITEM_SEPARATOR);
                var currentRow = 0;
                argsControls = new Array();

                for (var i = table.rows.length; i > 0; i--) {
                    table.deleteRow(i - 1);
                }

                for (i = 0; i < argsArray.length; i++) {
                    var newRow = table.insertRow(-1);
                    newRow.className = 'inputtext';
                    var headerCell = document.createElement('th');
                    headerCell.innerHTML = "<label>" + argsArray[i] + "</label>";
                    newRow.appendChild(headerCell, textCell);
                    var textCell = document.createElement('td');
                    textCell.innerHTML = "<input style=\"width:" + argsTextWidth + "\" type=\"text\" value=\"\" id=\"" + prefix + i + "\" name=\"" + prefix + i + "\" />";
                    newRow.appendChild(textCell);
                }
            }
        }


        function insertCommandOptions(commandList) {
            var ddlCommand1 = $('decCommand1');
            var ddlCommand2 = $('decCommand2');
            ddlCommand1.length = 0;
            ddlCommand2.length = 0;

            var optionArray = commandList.split(ITEM_SEPARATOR);
            var optionIndex = 0;

            for (i = 0; i < optionArray.length; i += 2) {
                ddlCommand1.options[optionIndex] = new Option(optionArray[i + 1], optionArray[i], false, false);
                ddlCommand2.options[optionIndex] = new Option(optionArray[i + 1], optionArray[i], false, false);
                optionIndex++;
            }
        }

        function buildCommandList() {
            if ((myClientDataEntry.currUserAction != 'reading')||($('decCommand1').length==0)) {
                var ddlDevice = $('decDeviceID');
                if (ddlDevice.selectedIndex != -1) {
                    var selectedDeviceID = ddlDevice.options[ddlDevice.selectedIndex].value;
                    var postBody = "modality=ajax" + "&exec=getCommandsHTML" + "&deviceID=" + selectedDeviceID;
                    new Request({url:'/ActionCommandInvocation.rix',
                                 onComplete: function(request) {
                                    insertCommandOptions(request);
                                    if (manageArgs) {
                                        BuildBothArgs('decCommand1');
                                    }}, 
                                 timeout: 5000
                    }).send(postBody);
                }
            }
        }
        
        window.addEvent('domready',function() {

            function details_onCancel() {
                var selectedType = $('decTypeID').selectedIndex;

                if (selectedType == 4) {
                    setVisibility(hideALL, 'none');
                }
            }

            function selectValue(control, value) {
                for (i = 0; i < control.length; i++) {
                    if (control.options[i].value == value) {
                        control.selectedIndex = i;
                    }
                }
            }

            function details_onAdd() {
                $('decTypeID').disabled = false;
                $('decTypeID').selectedIndex = 0;
                update_kind_details_visibility();
            }

            function details_onEdit() {
                $('decTypeID').disabled = true;
                var selectedType = $('decTypeID').selectedIndex;

                if (selectedType == 4) {
                    if ($('decDeviceID').length > 0) {
                        setVisibility(visCommand, '');
                        $('decDeviceID').removeEvent('change', buildCommandList);
                        $('decCommand1').removeEvent('change', BuildArgs1);
                        $('decCommand2').removeEvent('change', BuildArgs2);
                        var actionID = myClientDataEntry.getRecordID();
                        var postBody = "modality=ajax" + "&exec=loadData" + "&actionID=" + actionID;
                        new Request({url:'/ActionCommandInvocation.rix',
                                    onComplete: function(request) {
                                        var group = request.split(GROUP_SEPARATOR);
                                        var ddlDevices = $('decDeviceID');
                                        var ddlCommand1 = $('decCommand1');
                                        var ddlCommand2 = $('decCommand2');




                                        var settings = group[0].split(COMMAND_SEPARATOR);
                                        var argsA = settings[0].split(ARGS_SEPARATOR);
                                        var argsB = settings[1].split(ARGS_SEPARATOR);

                                        var deviceID = settings[2];
                                        if (deviceID == "" || deviceID == null) {

                                        } else {
                                            selectValue(ddlDevices, deviceID);
                                            insertCommandOptions(group[1]);
                                            selectValue(ddlCommand1, argsA[0]);
                                            selectValue(ddlCommand2, argsB[0]);
                                            if (manageArgs) {
                                                insertArguments(group[2], 'gArgs1', 'decArgA');
                                                insertArguments(group[3], 'gArgs2', 'decArgB');
                                                SetArguments('decArgA', argsA);
                                                SetArguments('decArgB', argsB);
                                            }
                                        }
                                        $('decDeviceID').addEvent('change', buildCommandList);
                                        $('decCommand1').addEvent('change', BuildArgs1);
                                        $('decCommand2').addEvent('change', BuildArgs2);
                                    }, 
                                  timeout: 5000
                        }).send(postBody);
                    } else {
                        setVisibility(hideALL, 'none');
                        $('gCommandMessage').style.display = '';
                    }
                }
            }



            // To Fix IE Event Invocation Order
            if (window.ie == true) {
                $('ToolBar1$ilbEdit').addEvent('click', details_onEdit);
                $('ToolBar1$ilbAdd').addEvent('click', details_onAdd);
                $('ToolBar1$ilbCancel').addEvent('click', details_onCancel);
            }

            myClientDataEntry = new clientDataEntry('list');

            if (window.ie == null) {
                $('ToolBar1$ilbEdit').addEvent('click', details_onEdit);
                $('ToolBar1$ilbAdd').addEvent('click', details_onAdd);
                $('ToolBar1$ilbCancel').addEvent('click', details_onCancel);
            }

            var visTwin = new Array('gcTwinA1', 'gcTwinA2', 'gcTwinA3', 'gcTwinSms', 'PanelTestPhone');
            var visPhone = new Array('gcPhone', 'PanelTestPhone');
            var visEMail = new Array('gcEmail', 'PanelTestEmail');
            
            // NOTE: [ERIK] PanelTestCommand removed because of a change in specifications.
            // var visCommand = new Array('gCommands1', 'gCommands2', 'gcDevice', 'gArgs1', 'gArgs2', 'PanelTestCommand');
            
            var visCommand = new Array('gCommands1', 'gCommands2', 'gcDevice', 'gArgs1', 'gArgs2');

            var visRelays = new Array('gcRelay1', 'gcRelay2', 'PanelTestRelays');

            var hideALL = new Array('gcTwinA1', 'gcTwinA2', 'gcTwinA3', 'gcTwinSms', 'PanelTestPhone', 'gcPhone', 'PanelTestPhone', 'gcEmail', 'PanelTestEmail', 'gCommands1', 'gCommands2', 'gcDevice', 'PanelTestCommand', 'gArgs1', 'gArgs2', 'gcRelay1', 'gcRelay2', 'PanelTestRelays', 'gCommandMessage');

            function setVisibility(array, value) {
                for (i = 0; i < array.length; i++) {
                    $(array[i]).style.display = value;
                }
            }
            
            function update_kind_details_visibility() {
                var selectedType = $('decTypeID').selectedIndex;
                setVisibility(hideALL, 'none');
                switch (selectedType) {
                    case 0: //TWIN
                        setVisibility(visTwin, '');
                        break;
                    case 1: // SMS
                        setVisibility(visPhone, '');
                        break;
                    case 2: // Email
                        setVisibility(visEMail, '');
                        break;
                    case 3: // Phone Call
                        setVisibility(visPhone, '');
                        break;
                    case 4: //Command
                        if (myClientDataEntry.currUserAction != 'reading') {
                            if ($('decDeviceID').length > 0) { setVisibility(visCommand, ''); }
                            else { $('gCommandMessage').style.display = ''; }
                        }
                        else {
                            setVisibility(hideALL, 'none');
                        }
                        break;
                    case 5: // Relay
                        setVisibility(visRelays, '');
                        break;
                }
            }

            $('decPort3').style.width = $('decPort2').style.width = $('decPort1').style.width = "50px";

            // Fix Table Margins
            var margin = "0 10px 0 10px";
            $('gCommands2').style.margin = $('gCommands1').style.margin = margin;
            $('gGridGroupDetails').style.margin = $('gArgs2').style.margin = $('gArgs1').style.margin = margin;

            update_kind_details_visibility();

            $('decTypeID').addEvent('change', update_kind_details_visibility);

            $('decDeviceID').addEvent('change', buildCommandList);
            $('decCommand1').addEvent('change', BuildArgs1);
            $('decCommand2').addEvent('change', BuildArgs2);

            //New
            var emailPanel = new testPanel('PanelTestEmailMessage',
                'PanelTestEmailImage',
                'PanelTestEmailProgress',
                ['btnSendEmail'],
                'decEmail',
                null,
                'sendEmail',
                60000);

            var smsPanel = new testPanel('PanelTestPhoneMessage',
                'PanelTestPhoneImage',
                'PanelTestPhoneProgress',
                ['btnSendSms', 'btnCall'],
                'decPhone',
                null,
                'sendSms',
                20000);

            //TODO
            //Twin should be managed too
            //if ($('decTypeID').selectedIndex == 0)
            //    phoneNumber = $('decTwinSms').value

            var phonePanel = new testPanel('PanelTestPhoneMessage',
                'PanelTestPhoneImage',
                'PanelTestPhoneProgress',
                ['btnSendSms', 'btnCall'],
                'decPhone',
                null,
                'sendCall',
                60000);

            function send_TestEmail() { emailPanel.onClick(); }
            function send_TestSms() { smsPanel.onClick(); }
            function send_TestPhone() { phonePanel.onClick(); }

            $('btnSendEmail').addEvent('click', send_TestEmail);
            $('btnSendSms').addEvent('click', send_TestSms);
            $('btnCall').addEvent('click', send_TestPhone);


            $('btnTestRelays').addEvent('click', send_TestRelays);
            $('btnTestCommand').addEvent('click', send_TestCommand);

function resetTest(buttonName, imageName, progressName,message)
{
                    $(buttonName).innerHTML = message;
                    $(imageName).style.display = 'none';
                    $(progressName).disabled = false;
}
function initTest(buttonName, imageName, progressName,messageName)
{

                $(buttonName).disabled = true;
                $(imageName).style.display = '';
                $(progressName).style.display = '';
                $(messageName).innerHTML = '';
}

            function send_TestCommand() {
            initTest('btnTestCommand','PanelTestCommandImage','PanelTestCommandProgress','PanelTestCommandMessage');
                
                var deviceID = "&deviceID=" + $('decDeviceID').options[$('decDeviceID').selectedIndex].value;
                var commandOnActiveID = "&commandActive=" + $('decCommand1').options[$('decCommand1').selectedIndex].value;
                var commandOnInactiveID = "&commandInactive=" + $('decCommand2').options[$('decCommand2').selectedIndex].value;
                var argumentsOnActive = "&argsActive=" + GetArguments('decArgA');
                var argumentsOnInActive = "&argsInactive=" + GetArguments('decArgB');

                var postBody = "modality=ajax" + "&exec=sendCommand" + deviceID + commandOnActiveID + commandOnInactiveID + argumentsOnActive + argumentsOnInActive;
                new Request({url:'/ActionTestInvocation.rix', 
                    onComplete: function(request) 
                            {
                            resetTest('PanelTestCommandMessage','PanelTestCommandImage','btnTestCommand',request);
                               
                            },
                    onFailure: function(){resetTest('PanelTestCommandMessage','PanelTestCommandImage','btnTestCommand',TIMEOUT_MESSAGE);},
                     timeout: 5000
                }).send(postBody);
            }

            function send_TestRelays() {
            initTest('btnTestRelays','PanelTestRelaysImage','PanelTestRelaysProgress','PanelTestRelaysMessage');

                var relay1value = $('decRelay1').checked;
                var relay2value = $('decRelay2').checked;

                var postBody = "modality=ajax" + "&exec=sendRelays" + "&relay1=" + relay1value + "&relay2=" + relay2value;
                new Request({url:'/ActionTestInvocation.rix', 
                             onComplete: function(request) 
                                {
                                resetTest('PanelTestRelaysMessage','PanelTestRelaysImage','btnTestRelays',request);
                                },
                             onFailure: function(){resetTest('PanelTestRelaysMessage','PanelTestRelaysImage','btnTestRelays',TIMEOUT_MESSAGE);}, 
                             timeout: 5000
                }).send(postBody);
            }
        });          //]]>	
    </script>

    <ucGeneralMessage:GeneralMessage ID="GeneralMessage1" ExtraCssClass="actionfeedback"
        runat="server" />
    <div id="boxSettingsAccountsGroups">
        <table class="wkaDataEntry">
            <tr>
                <td class="wdeRecordList" style="width: 400px">
                    <blockquote id="boxAccountGroupList" class="list">
                        <h5 id="GroupsListTitle" runat="server">
                        </h5>
                        <ucGenericGrid:GenericGrid ID="gGridActions" IsList="true" runat="server">
                            <ucGenericContainer:GenericContainer ID="groupContainer" IdFieldName="Id" ShowHeader="true"
                                RowDisabledCssClass="disabled" runat="server">
                                <ucGenericLiteral:GenericLiteral ID="colIcon" FieldName="Icon" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericLiteral:GenericLiteral>
                                <ucGenericText:GenericText ID="colName" FieldName="Name" DisablingFieldName="IsEnabled"
                                    Selectable="true" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericLiteral:GenericLiteral ID="colDescription" FieldName="Description" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericLiteral:GenericLiteral>
                            </ucGenericContainer:GenericContainer>
                        </ucGenericGrid:GenericGrid>
                    </blockquote>
                </td>
                <td class="wdeRecordDetail">
                    <ucGenericClientServerConnector:GenericClientServerConnector ID="GenericClientServerConnector1"
                        runat="server" />
                    <blockquote id="boxAccountGroupDetail" class="detail">
                        <h5 id="GroupDetailsTitle" runat="server">
                        </h5>
                        <ucGenericGrid:GenericGrid ID="gGridGroupDetails" OutputID="true" runat="server">
                            <ucGenericContainer:GenericContainer RowCssClass="isenabled" ID="gcEnabled" ShowHeader="false"
                                runat="server">
                                <ucGenericCheckBox:GenericCheckBox ID="decEnabled" FieldName="IsEnabled" Selected="true"
                                    HasHtmlLabel="true" Span="4" LabelOnTheLeft="false" runat="server">
                                </ucGenericCheckBox:GenericCheckBox>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer RowCssClass="inputtext" ID="gcType" ShowHeader="false"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblType" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericSelect:GenericSelect ID="decTypeID" PropertyKey="Id" PropertyToDisplay="Name"
                                    runat="server">
                                </ucGenericSelect:GenericSelect>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer ID="gcName" RowCssClass="inputtext" runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblName" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox Span="3" ID="decName" FieldName="Name" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcTwinA1" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblAddress1" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox ID="decAddress1" FieldName="Address1" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                                <ucGenericText:GenericText IsHeader="true" ID="lblPort1" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox ID="decPort1" FieldName="Port1" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcTwinA2" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblAddress2" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox ID="decAddress2" FieldName="Address2" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                                <ucGenericText:GenericText IsHeader="true" ID="lblPort2" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox ID="decPort2" FieldName="Port2" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcTwinA3" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblAddress3" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox ID="decAddress3" FieldName="Address3" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                                <ucGenericText:GenericText IsHeader="true" ID="lblPort3" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox ID="decPort3" FieldName="Port3" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcTwinSms" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblTwinSms" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox ID="decTwinSms" Span="3" FieldName="Sms" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcPhone" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblPhone" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox ID="decPhone" Span="3" FieldName="Phone" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcEmail" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblEmail" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericTextBox:GenericTextBox ID="decEmail" Span="3" FieldName="Email" runat="server">
                                </ucGenericTextBox:GenericTextBox>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcDevice" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblDevice" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericSelect:GenericSelect ID="decDeviceID" Span="3" PropertyKey="Id" PropertyToDisplay="Name"
                                    runat="server">
                                </ucGenericSelect:GenericSelect>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcRelay1" RowCssClass="inputcheckBox"
                                runat="server">
                                <ucGenericCheckBox:GenericCheckBox HasHtmlLabel="true" LabelOnTheLeft="false" id="decRelay1"
                                    runat="server">
                                </ucGenericCheckBox:GenericCheckBox>
                                <ucGenericDirectOutput:GenericDirectOutput Span="3" ID="decRelay1Info" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericDirectOutput:GenericDirectOutput>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcRelay2" RowCssClass="inputcheckBox"
                                runat="server">
                                <ucGenericCheckBox:GenericCheckBox HasHtmlLabel="true" LabelOnTheLeft="false" id="decRelay2"
                                    runat="server">
                                </ucGenericCheckBox:GenericCheckBox>
                                <ucGenericDirectOutput:GenericDirectOutput Span="3" ID="decRelay2Info" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericDirectOutput:GenericDirectOutput>
                            </ucGenericContainer:GenericContainer>
                        </ucGenericGrid:GenericGrid>
                        <ucGenericGrid:GenericGrid ID="gCommands1" OutputID="true" runat="server">
                            <ucGenericContainer:GenericContainer ID="gcCommandHeader1" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericDirectOutput:GenericDirectOutput Span="2" ID="command1Header" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericDirectOutput:GenericDirectOutput>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcCommand1" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblCommand1" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericDirectOutput:GenericDirectOutput ID="decCommands1" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericDirectOutput:GenericDirectOutput>
                            </ucGenericContainer:GenericContainer>
                        </ucGenericGrid:GenericGrid>
                        <ucGenericGrid:GenericGrid ID="gArgs1" OutputID="true" runat="server">
                        </ucGenericGrid:GenericGrid>
                        <ucGenericGrid:GenericGrid ID="gCommands2" OutputID="true" runat="server">
                            <ucGenericContainer:GenericContainer ID="gcCommandHeader2" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericDirectOutput:GenericDirectOutput Span="2" ID="command2Header" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericDirectOutput:GenericDirectOutput>
                            </ucGenericContainer:GenericContainer>
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcCommand2" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericText:GenericText IsHeader="true" ID="lblCommand2" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericDirectOutput:GenericDirectOutput ID="decCommands2" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericDirectOutput:GenericDirectOutput>
                            </ucGenericContainer:GenericContainer>
                        </ucGenericGrid:GenericGrid>
                        <ucGenericGrid:GenericGrid ID="gArgs2" OutputID="true" runat="server">
                        </ucGenericGrid:GenericGrid>
                        <ucGenericGrid:GenericGrid ID="gCommandMessage" OutputID="true" runat="server">
                            <ucGenericContainer:GenericContainer ID="gcCommandMessage" runat="server">
                                <ucGenericDirectOutput:GenericDirectOutput ID="decCommandMessage" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericDirectOutput:GenericDirectOutput>
                            </ucGenericContainer:GenericContainer>
                        </ucGenericGrid:GenericGrid>
                        <ucGenericGrid:GenericGrid ID="gTest" OutputID="true" runat="server">
                            <ucGenericContainer:GenericContainer OutputID="true" ID="gcTest" RowCssClass="inputtext"
                                runat="server">
                                <ucGenericDirectOutput:GenericDirectOutput ID="decSendTest" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericDirectOutput:GenericDirectOutput>
                            </ucGenericContainer:GenericContainer>
                        </ucGenericGrid:GenericGrid>
                    </blockquote>
                </td>
            </tr>
        </table>
    </div>
</asp:Content>
<asp:Content ID="Content4" runat="server" ContentPlaceHolderID="SubtabsArea">
    <ucSubtabMenuSettingsAlarms:SubtabMenuSettingsAlarms ID="SubtabMenuSettingsAlarms1"
        runat="server" />
</asp:Content>
<asp:Content ID="Content5" runat="server" ContentPlaceHolderID="PageTitleArea">
    <ucPageTitle:PageTitle ID="PageTitle1" runat="server">
    </ucPageTitle:PageTitle>
</asp:Content>
