<%@ Page Language="C#" MasterPageFile="~/WorkingArea.master" AutoEventWireup="true" CodeBehind="ComputerUpgrade.aspx.cs" Inherits="Invensys.Compact.Presentation.Web.Settings.ComputerUpgrade" %>

<%@ Register Src="~/UC/PageTitle.ascx" TagName="PageTitle" TagPrefix="ucPageTitle" %>
<%@ Register Src="~/UC/GeneralMessage.ascx" TagName="GeneralMessage" TagPrefix="ucGeneralMessage" %>
<%@ Register Src="~/UC/UpdateFileUpload.ascx" TagName="UpdateFileUpload" TagPrefix="ucUpdateFileUpload" %>
<%@ Register Src="~/UC/ParameterMapFileSlot.ascx" TagName="ParameterMapFileSlot" TagPrefix="ucParameterMapFileSlot" %>

<asp:Content ID="Content3" ContentPlaceHolderID="ContentArea" runat="Server">

    <script language="JavaScript" type="text/JavaScript">
        //<![CDATA["
        window.addEvent('domready',function() {

            document.getElements('span.spanLinkClass').each(function(spn) {
                if (spn.innerHTML.length < 1) {
                    var myTr = spn.getParent().getParent('tr');
                    myTr.setStyle('display', 'none');
                }
            });

        });
        //]]>	
    </script>


    <asp:Literal ID="javaScriptPlaceHolder" runat="server" />
    <ucGeneralMessage:GeneralMessage ID="GeneralMessage1" ExtraCssClass="actionfeedback" runat="server" />
    <!-- ### WAIT-UPLOADING ### -->
    <div id="fileLoader" class="generalmessage updateprogress" style="display: none;">
        <p>
            <img src="/media/img/Common/Ajax/Progress3.gif" alt="" />
            <asp:Literal ID="litLoadingInProgress" runat="server" />
        </p>
    </div>
    <div id="box">
        <table class="wkaDataEntry">
            <tr>
                <td class="wdeRecordDetail">
                    <blockquote class="detail">
                        <h5>
                            <asp:Literal ID="literalBoxTitle" runat="server"></asp:Literal>
                        </h5>
                        <table>
                            <tr>
                                <td id="tdCancel" colspan="4">
                                    <a href="ComputerUpgrade.aspx?Cancel=1" style="margin: 10px 5px 2px 3px; padding: 5px 10px; width: 100px; border-top: 1px solid #cccccc; border-bottom: 1px solid black;
                                        border-left: 1px solid #cccccc; border-right: 1px solid black; background: #FCFCFC; text-align: center; text-decoration: none; font: normal 12px Verdana; font-weight: bold;
                                        color: red;">
                                        <asp:Literal ID="litCancelUpgrade" runat="server" />
                                    </a>
                                </td>
                            </tr>                            
                            <ucUpdateFileUpload:UpdateFileUpload id="uploadOperatingSystem" runat="server"/>
                            <asp:Literal ID="LitOs" runat="server" />
                            <ucUpdateFileUpload:UpdateFileUpload id="uploadApplication" runat="server" />
                            <asp:Literal ID="litApplication" runat="server" />
                            <ucUpdateFileUpload:UpdateFileUpload id="uploadLanguages" runat="server" />
                            <asp:Literal ID="litLanguages" runat="server" />
                            <ucUpdateFileUpload:UpdateFileUpload id="uploadGenericSettings" runat="server" />
                            <ucUpdateFileUpload:UpdateFileUpload id="uploadNetworkNamingSnapshot" runat="server" />
                            <ucUpdateFileUpload:UpdateFileUpload id="uploadScheduledActionsFile" runat="server" />
                            <asp:Literal ID="litScheduledActionsFile" runat="server" />
                            <ucUpdateFileUpload:UpdateFileUpload id="uploadParameterPartialMap" runat="server" />
                            <asp:Literal ID="litMessage" runat="server" />
                            <ucParameterMapFileSlot:ParameterMapFileSlot id="parameterMapFileSlot_0" runat="server" />
                            <ucParameterMapFileSlot:ParameterMapFileSlot id="parameterMapFileSlot_1" runat="server" />
                            <ucParameterMapFileSlot:ParameterMapFileSlot id="parameterMapFileSlot_2" runat="server" />
                            <ucParameterMapFileSlot:ParameterMapFileSlot id="parameterMapFileSlot_3" runat="server" />
                            <ucParameterMapFileSlot:ParameterMapFileSlot id="parameterMapFileSlot_4" runat="server" />                             
                            <ucUpdateFileUpload:UpdateFileUpload id="uploadDeviceDrivers" runat="server" />
                            <asp:Literal ID="litDeviceDrivers" runat="server" />
                        </table>
                    </blockquote>
                </td>
            </tr>
        </table>
    </div>
</asp:Content>
<asp:Content ID="Content5" runat="server" ContentPlaceHolderID="PageTitleArea">
    <ucPageTitle:PageTitle ID="PageTitle1" runat="server">
    </ucPageTitle:PageTitle>
</asp:Content>
