<%@ Page Language="C#" EnableEventValidation="true" MasterPageFile="~/WorkingArea.master"
    AutoEventWireup="false" Inherits="Invensys.Compact.Presentation.Web.HistoricalTable_02Lite"
    EnableViewState="false" %>

<%@ Register Src="~/UC/PageTitle.ascx" TagName="PageTitle" TagPrefix="ucPageTitle" %>
<%@ Register Src="~/UC/ToolBar.ascx" TagName="ToolBar" TagPrefix="ucToolBar" %>
<%@ Register Src="~/UC/GeneralMessage.ascx" TagName="GeneralMessage" TagPrefix="ucGeneralMessage" %>
<%@ Register Src="~/UC/SubtabMenuNetworks.ascx" TagName="SubtabMenuNetworks" TagPrefix="uc1" %>
<%@ Register Src="~/UC/NetworksGrid.ascx" TagName="NetworksGrid" TagPrefix="uc2" %>
<%@ Register Src="~/UC/NetworkFilter.ascx" TagName="NetworkFilter" TagPrefix="ucNetworkFilter" %>
<asp:Content ID="Content5" runat="server" ContentPlaceHolderID="PageTitleArea">
    <ucPageTitle:PageTitle ID="PageTitle1" runat="server">
    </ucPageTitle:PageTitle>
</asp:Content>
<asp:Content ID="Content1" ContentPlaceHolderID="FilterArea" runat="server">

    <script language="JavaScript" type="text/JavaScript" src="/script/js/liteGrid.js" />

    <script language="JavaScript" type="text/JavaScript">	
    	window.addEvent('domready',function() { 
				enableDisableSamplingNumber();
			});
							
        function enableDisableSamplingNumber()
        {         
            var visSetting = ($('checkBoxUseSamples').checked);
            $('textBoxSamplings').disabled = !visSetting;
            $('labelNumberOfRecords').disabled = !visSetting;            
        }		
    </script>

    <div>
        <h6>
            <span>
                <asp:Label ID="lblColumnsCount" runat="server" /></span></h6>
        <table>
            <tr>
                <td>
                    <asp:DropDownList ID="ddlColumnsCount" OnSelectedIndexChanged="ddlColumnsCount_SelectedIndexChanged"
                        AutoPostBack="true" runat="server">
                    </asp:DropDownList>
                </td>
            </tr>
        </table>
        <h6>
            <asp:Label ID="labelProfile" runat="server" />
        </h6>
        <blockquote>
            <p>
                <span id="ctl00_ContentArea_profileName">
                    <asp:Label ID="labelProfileName" runat="server" /></span></p>
            <p>
                <span id="ctl00_ContentArea_profileSettings">
                    <asp:Label ID="labelProfileSettings" runat="server" /></span></p>
        </blockquote>
        <h6>
            <asp:Label ID="labelTimeIntervals" runat="server" /></h6>
        <blockquote>
            <p>
                <asp:Label ID="labelFrom" runat="server" /></p>
            <p>
                <asp:Label ID="labelDateFrom" runat="server" /></p>
            <p>
                <asp:Label ID="labelTo" runat="server" /></p>
            <p>
                <asp:Label ID="labelDateTo" runat="server" /></p>
        </blockquote>
    </div>
    <div>
        <h6>
            <asp:Label ID="labelConfigurations" runat="server" />
        </h6>
        <blockquote>
            <p>
                <asp:Literal ID="literalConfigurationList" runat="server"></asp:Literal></p>
        </blockquote>
    </div>
      <h6>
        <asp:Label ID="lblControls" runat="server" /></h6>
    <table>
        <tr>
            <td>
                <asp:Image ID="AnalogInputsImageUrl" runat="server" />
            </td>
            <td>
                <asp:CheckBox ID="chkAnalogInputs" AutoPostBack="false" Checked="true" runat="server" />
            </td>
        </tr>
        <tr>
            <td>
                <asp:Image ID="DigitalInputsImageUrl" runat="server" />
            </td>
            <td>
                <asp:CheckBox ID="chkDigitalInputs" AutoPostBack="false" Checked="true" runat="server" />
            </td>
        </tr>
        <tr>
            <td>
                <asp:Image ID="StatesImageUrl" runat="server" />
            </td>
            <td>
                <asp:CheckBox ID="chkStates" AutoPostBack="false" Checked="true" runat="server" />
            </td>
        </tr>
        <tr>
            <td>
                <asp:Image ID="AlarmsImageUrl" runat="server" />
            </td>
            <td>
                <asp:CheckBox ID="chkAlarms" AutoPostBack="false" Checked="true" runat="server" />
            </td>
        </tr>
    </table>
    <div>
        <h6>
            <asp:Label ID="labelUndersampling" runat="server" /></h6>
        <blockquote>
            <p>
                <asp:CheckBox ID="checkBoxUseSamples" runat="server" onClick="enableDisableSamplingNumber();" /></p>
            <p>
                <asp:Label ID="labelNumberOfRecords" runat="server" /><asp:TextBox ID="textBoxSamplings"
                    runat="server" /></p>
        </blockquote>
    </div>
    <ucNetworkFilter:NetworkFilter ID="NetworkFilter1" runat="server" />
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ToolbarArea" runat="server">
    <ucToolBar:ToolBar ID="toolBar" BackVisible="true" SelectionCommandsVisible="true"
        GridExplorationVisible="true" NextVisible="true" runat="server" />
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="ContentArea" runat="server">
    <ucGeneralMessage:GeneralMessage ID="generalMessage" ExtraCssClass="actionstop" runat="server" />
    <asp:Literal ID="RealTimeTableContent" runat="server" />

    <script language="javascript" type="text/javascript">
        //<![CDATA[
        window.addEvent('domready',function() {

            var myLiteGridNetworkTable = new liteGridNetworkTable();

        });
        //]]>	   
    </script>

    <!--uc2:NetworksGrid ID="networksGrid" Level2CheckedOnOnLine="true" Level3CheckedOnOnLine="true"
        runat="server" /-->
    <div class="clearer">
    </div>
</asp:Content>
