<%@ Page Language="C#" EnableEventValidation="true" MasterPageFile="~/WorkingArea.master"
    AutoEventWireup="false" Inherits="Invensys.Compact.Presentation.Web.RealTimeTable" EnableViewState="false"%>
<%@ Register Src="~/UC/ToolBar.ascx" TagName="ToolBar" TagPrefix="ucToolBar" %>
<%@ Register Src="~/UC/PageTitle.ascx" TagName="PageTitle" TagPrefix="ucPageTitle" %>
<asp:Content ID="Content1" ContentPlaceHolderID="FilterArea" runat="server"> 
    
    <script language="JavaScript" type="text/JavaScript" src="/script/js/liteGrid.js" />
    
    <h6><span><asp:Label ID="lblColumnsCount" runat="server" /></span></h6>
    <table>
        <tr>
            <td>
                <asp:DropDownList ID="ddlColumnsCount" OnSelectedIndexChanged="ddlColumnsCount_SelectedIndexChanged" AutoPostBack="true" runat="server"></asp:DropDownList>    
            </td>
        </tr>
    </table>
    <h6><span><asp:Label ID="lblFilters" runat="server" /></span></h6>
    <table id="sgnFilterShow_Devices">
        <tr>
            <td><asp:Label ID="lblDescription" runat="server" /></td>
        </tr>
        <tr>
            <td>
                <asp:TextBox ID="inpDevDescription" AutoPostBack="false" runat="server" />
            </td>
        </tr>
        <tr>
            <td>
                <asp:Button ID="btnFilterByDescription" runat="server" />
            </td>
        </tr>
    </table>
    <h6><asp:Label ID="lblControls" runat="server" /></h6>
	<table>
        <tr><td><asp:CheckBox ID="chkResources" runat="server" AutoPostBack="false" /></td></tr>
        <tr><td><table>
            <tr>
                <td><asp:Image ID="AnalogInputsImageUrl" runat="server" /></td>
                <td><asp:CheckBox ID="chkAnalogInputs" AutoPostBack="false" runat="server" Checked="true" /></td>
            </tr>
            <tr>
                <td><asp:Image ID="DigitalInputsImageUrl" runat="server" /></td>
                <td><asp:CheckBox ID="chkDigitalInputs" AutoPostBack="false" runat="server" Checked="true" /></td>
            </tr>
            <tr>
                <td><asp:Image ID="StatesImageUrl" runat="server" /></td>
                <td><asp:CheckBox ID="chkStates" AutoPostBack="false" runat="server" Checked="true" /></td>
            </tr>
        </table></td></tr>
    </table>
    <h6><asp:Label ID="lblLegenda" runat="server" CssClass="legend"/></h6>
    <table class="legend">
        <tr>
            <td><asp:Image ID="compressorOn" runat="server" /></td>
            <td><asp:Image ID="compressorOff" runat="server" /></td>
            <td><asp:Label ID="compressor" runat="server" /></td>
        </tr>
        <tr>
            <td><asp:Image ID="defrostOn" runat="server" /></td>
            <td><asp:Image ID="defrostOff" runat="server" /></td>
            <td><asp:Label ID="defrost" runat="server" /></td>
        </tr>
        <tr>
            <td><asp:Image ID="fanOn" runat="server" /></td>
            <td><asp:Image ID="fanOff" runat="server" /></td>
            <td><asp:Label ID="fan" runat="server" /></td>
        </tr>
        <tr>
            <td><asp:Image ID="doorOn" runat="server" /></td>
            <td><asp:Image ID="doorOff" runat="server" /></td>
            <td><asp:Label ID="door" runat="server" /></td>
        </tr>
    </table>
</asp:Content>
<asp:Content ID="Content2" ContentPlaceHolderID="ContentArea" runat="server" 
    class="wkaWrapperArea narrowFilter showFilter narrowFilter showFilter narrowFilter showFilter narrowFilter showFilter">
    <asp:Literal ID="RealTimeTableContent" runat="server" />
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="ToolbarArea" runat="Server">
    <ucToolBar:ToolBar ID="ToolBar1" GridFilterVisible="true" GridExplorationVisible="true" runat="server" />
</asp:Content>
<asp:Content ID="Content5" runat="server" ContentPlaceHolderID="PageTitleArea">
    <ucPageTitle:PageTitle ID="PageTitle1" runat="server"></ucPageTitle:PageTitle>
</asp:Content>