<%@ Page Language="C#" MasterPageFile="~/WorkingArea.master" AutoEventWireup="true"
    CodeBehind="Scheduler_Actions.aspx.cs" Inherits="Invensys.Compact.Presentation.Web.Settings.Scheduler_Actions" %>

<%@ Register Src="~/UC/PageTitle.ascx" TagName="PageTitle" TagPrefix="ucPageTitle" %>
<%@ Register Src="~/UC/SubtabMenuScheduler.ascx" TagName="SubtabMenuScheduler" TagPrefix="ucSubtabMenuScheduler" %>
<%@ Register Src="~/UC/ToolBar.ascx" TagName="ToolBar" TagPrefix="ucToolBar" %>
<%@ Register Src="~/UC/GenericGrid.ascx" TagName="GenericGrid" TagPrefix="ucGenericGrid" %>
<%@ Register Src="~/UC/GenericContainer.ascx" TagName="GenericContainer" TagPrefix="ucGenericContainer" %>
<%@ Register Src="~/UC/GenericTextBox.ascx" TagName="GenericTextBox" TagPrefix="ucGenericTextBox" %>
<%@ Register Src="~/UC/GenericText.ascx" TagName="GenericText" TagPrefix="ucGenericText" %>
<%@ Register Src="~/UC/GenericRadio.ascx" TagName="GenericRadio" TagPrefix="ucGenericRadio" %>
<%@ Register Src="~/UC/GenericLiteral.ascx" TagName="GenericLiteral" TagPrefix="ucGenericLiteral" %>
<%@ Register Src="~/UC/GenericCheckBox.ascx" TagName="GenericCheckBox" TagPrefix="ucGenericCheckBox" %>
<%@ Register Src="~/UC/GenericTextArea.ascx" TagName="GenericTextArea" TagPrefix="ucGenericTextArea" %>
<%@ Register Src="~/UC/GenericSelect.ascx" TagName="GenericSelect" TagPrefix="ucGenericSelect" %>
<%@ Register Src="~/UC/GeneralMessage.ascx" TagName="GeneralMessage" TagPrefix="ucGeneralMessage" %>
<%@ Register Src="~/UC/GenericClientServerConnector.ascx" TagName="GenericClientServerConnector"
    TagPrefix="ucGenericClientServerConnector" %>
<%@ Register Src="~/UC/GenericDirectOutput.ascx" TagName="GenericDirectOutput" TagPrefix="ucGenericDirectOutput" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ToolbarArea" runat="Server">
    <ucToolBar:ToolBar ID="ToolBar1" PageEditCommandsVisible="true" RecordEditCommandsVisible="true"
        FilterPreviewVisible="true" runat="server" />
</asp:Content>
<asp:Content runat="server" ID="topForm" ContentPlaceHolderID="TopForm">
    <div class="modalPopup" id="modalPopUpContainer">
        <div class="overlay-decorator">
            <!--&nbsp;-->
        </div>
        <div class="overlay-wrap">
            <div class="overlay">
                <div class="dialog-decorator">
                    <!--&nbsp;-->
                </div>
                <div class="dialog-wrap">
                    <div onclick="javascript:event.cancelBubble = true;if(event.stopPropagation) event.stopPropagation();"
                        class="bottom_div">
                        <div class="content_div">
                            <h1 runat="server" id="headerFilters">
                            </h1>
                            <div class="inner_div">
                                <div class="border_wrap_ext">
                                    <div class="border_wrap_int">
                                        <div class="leftCol">
                                            <div id="filterList">
                                                <h6>
                                                    <span id="title_filterList">
                                                        <!--&nbsp;-->
                                                    </span><a href="#" id="btn_add_selector">Add Selector</a>
                                                </h6>
                                                <div id="nodeList">
                                                    <!--&nbsp;-->
                                                </div>
                                            </div>
                                        </div>
                                        <div class="rightCol">
                                            <div id="editList">
                                                <div class="" id="selectorEdit">
                                                    <h6 id="title_filterSelector" class="title_filter">
                                                        <!--&nbsp;-->
                                                    </h6>
                                                    <div class="filter_entry">
                                                        <p>
                                                            <label id="label_type_selector">
                                                                Type</label>
                                                            <select id="ddl_type_selector">
                                                                <!--&nbsp;-->
                                                            </select>
                                                        </p>
                                                        <p>
                                                            <label id="label_resources_selector">
                                                                Resources</label>
                                                            <span id="checkboxs_resource_selector">
                                                                <input type="checkbox" value='analog' /><span><asp:Literal runat="server" ID="resource_selector_type_analog"></asp:Literal></span><br />
                                                                <input type="checkbox" value='digital' /><span><asp:Literal runat="server" ID="resource_selector_type_digital"></asp:Literal></span><br />
                                                                <input type="checkbox" value='status' /><span><asp:Literal runat="server" ID="resource_selector_type_status"></asp:Literal></span><br />
                                                                <input type="checkbox" value='alarm' /><span><asp:Literal runat="server" ID="resource_selector_type_alarm"></asp:Literal></span><br />
                                                            </span>
                                                        </p>
                                                        <p>
                                                            <input value="Save" type="button" id="btn_save_selector" />
                                                        </p>
                                                    </div>
                                                </div>
                                                <div class="" id="interfaceEdit">
                                                    <h6 id="title_quickSetInterface" class="title_quick_get">
                                                        <!--&nbsp;-->
                                                    </h6>
                                                    <div class="quick_get_entry">
                                                        <p>
                                                            <label id="title_attributeInterface">
                                                                Attribute</label>
                                                            <select id="ddl_attr_interface">
                                                                <!--&nbsp;-->
                                                            </select>
                                                        </p>
                                                        <p>
                                                            <label id="title_valueInterface">
                                                                Value
                                                            </label>
                                                            <select id="ddl_value_interface">
                                                                <!--&nbsp;-->
                                                            </select>
                                                            <img alt="Please wait" id="pl_icon_quick_interface" src="/media/img/Others/ActionSheduler/ddl_update.gif" />
                                                        </p>
                                                        <p>
                                                            <input value="Set value" type="button" id="btn_set_interface" />
                                                        </p>
                                                    </div>
                                                    <h6 id="title_filterInterface" class="title_filter">
                                                        <!--&nbsp;-->
                                                    </h6>
                                                    <div class="filter_entry">
                                                        <p>
                                                            <label id="label_id_interface">
                                                                ID</label>
                                                            <input type="text" id="filter_interface_id" />
                                                            <img alt="Warning Icon" id="val_id_interface" src="/media/img/Others/ActionSheduler/validation_warning.gif" />
                                                        </p>
                                                        <p>
                                                            <label id="label_name_interface">
                                                                Name</label>
                                                            <input type="text" id="filter_interface_name" />
                                                            <img alt="Warning Icon" id="val_name_interface" src="/media/img/Others/ActionSheduler/validation_warning.gif" />
                                                        </p>
                                                        <p>
                                                            <input type="button" value="save" id="btn_save_interface" />
                                                        </p>
                                                    </div>
                                                </div>
                                                <div class="" id="deviceEdit">
                                                    <h6 id="title_quickSetDevice" class="title_quick_get">
                                                        <!--&nbsp;-->
                                                    </h6>
                                                    <div class="quick_get_entry">
                                                        <p>
                                                            <label id="title_attributeDevice">
                                                                Attribute</label>
                                                            <select id="ddl_attr_device">
                                                                <!--&nbsp;-->
                                                            </select>
                                                        </p>
                                                        <p>
                                                            <label id="title_interfaceDevice">
                                                                Interface</label>
                                                            <select id="ddl_interface_device">
                                                                <!--&nbsp;-->
                                                            </select>
                                                        </p>
                                                        <p>
                                                            <label id="title_valueDevice">
                                                                Value</label>
                                                            <select id="ddl_value_device">
                                                                <!--&nbsp;-->
                                                            </select>
                                                            <img alt="Please wait" id="pl_icon_quick_device" src="/media/img/Others/ActionSheduler/ddl_update.gif" />
                                                        </p>
                                                        <p>
                                                            <input value="Set value" type="button" id="btn_set_device" />
                                                        </p>
                                                    </div>
                                                    <h6 id="title_filterDevice" class="title_filter">
                                                        <!--&nbsp;-->
                                                    </h6>
                                                    <div class="filter_entry">
                                                        <p>
                                                            <label id="label_address_device">
                                                                Address</label>
                                                            <input type="text" id="filter_device_address" />
                                                            <img alt="Warning Icon" id="val_address_device" src="/media/img/Others/ActionSheduler/validation_warning.gif" />
                                                        </p>
                                                        <p>
                                                            <label id="label_model_device">
                                                                Model</label>
                                                            <input type="text" id="filter_device_model" /></p>
                                                        <p>
                                                            <label id="label_name_device">
                                                                Name</label>
                                                            <input type="text" id="filter_device_name" />
                                                        </p>
                                                        <p>
                                                            <input type="button" value="save" id="btn_save_device" />
                                                        </p>
                                                    </div>
                                                </div>
                                                <div class="" id="resourceEdit">
                                                    <h6 id="title_filterResource" class="title_filter">
                                                        <!--&nbsp;-->
                                                    </h6>
                                                    <div class="filter_entry">
                                                        <p>
                                                            <label id="label_id_resource">
                                                                ID</label>
                                                            <input type="text" id="filter_resource_id" />
                                                            <img alt="Warning Icon" id="val_id_resource" src="/media/img/Others/ActionSheduler/validation_warning.gif" />
                                                        </p>
                                                        <p>
                                                            <label id="label_name_resource">
                                                                Name</label>
                                                            <input type="text" id="filter_resource_name" /></p>
                                                        <p>
                                                            <label id="label_type_resource">
                                                                Type</label>
                                                            <select id="ddl_type_resource">
                                                                <!--&nbsp;-->
                                                            </select>
                                                        </p>
                                                        <p>
                                                            <input type="button" value="save" id="btn_save_resource" />
                                                        </p>
                                                    </div>
                                                </div>
                                            </div>
                                        </div>
                                        <div style="clear: both">
                                            <!--&nbsp;-->
                                        </div>
                                    </div>
                                </div>
                                <div class="bottom_div">
                                    <a runat="server" id="btnPopUpFiltersSave" class="modalToolbarButton" style="background-image: url(/media/img/Toolbar/GenericSave.png);">
                                    </a><a runat="server" id="btnPopUpFiltersClose" class="modalToolbarButton" style="background-image: url(/media/img/Toolbar/GenericCancel.png);">
                                    </a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</asp:Content>
<asp:Content runat="server" ID="cssContent" ContentPlaceHolderID="CssArea">

    <script language="JavaScript" type="text/JavaScript" src="/script/js/datepicker.js"></script>

    <script language="JavaScript" type="text/JavaScript" src="/script/js/jxlib.js"></script>

    <script language="JavaScript" type="text/JavaScript" src="/script/js/actionscheduler.js"></script>

    <asp:Literal ID="modalPopupCSSLink" runat="server"></asp:Literal>
    <link rel="stylesheet" type="text/css" href="/media/css/datepicker_vista.css" />
    <link rel="stylesheet" type="text/css" href="/media/css/jxt/jxtheme.css" />
    <link rel="stylesheet" type="text/css" href="/media/css/actionscheduler.css" />
    <asp:Literal ID="treeviewCSSLink" runat="server"></asp:Literal>
</asp:Content>
<asp:Content ID="Content3" ContentPlaceHolderID="ContentArea" runat="Server">
    <asp:Literal ID="javascriptArrays" runat="server"></asp:Literal>
    <ucGeneralMessage:GeneralMessage ID="GeneralMessage1" ExtraCssClass="actionfeedback"
        runat="server" />
    <div id="boxSettingsAccountsGroups">
        <table class="wkaDataEntry">
            <tr>
                <td class="wdeRecordList" style="width: 270px">
                    <blockquote id="boxAlarmCategoriesList" class="list">
                        <h5 id="scheduledActionListTitle" runat="server">
                        </h5>
                        <ucGenericGrid:GenericGrid ID="gGridScheduledActions" IsList="true" runat="server">
                            <ucGenericContainer:GenericContainer ID="categoryContainer" IdFieldName="Id" ShowHeader="true"
                                RowDisabledCssClass="disabled" runat="server">
                                <ucGenericText:GenericText ID="colName" FieldName="Name" DisablingFieldName="Enabled"
                                    Selectable="true" runat="server">
                                </ucGenericText:GenericText>
                                <ucGenericLiteral:GenericLiteral ID="colType" FieldName="Icon" HasHtmlLabel="false"
                                    runat="server">
                                </ucGenericLiteral:GenericLiteral>
                            </ucGenericContainer:GenericContainer>
                        </ucGenericGrid:GenericGrid>
                    </blockquote>
                </td>
                <td class="wdeRecordDetail" style="padding-right: 10px">
                    <table style="margin: 0; padding: 0">
                        <tr style="margin: 0; padding: 0">
                            <td style="margin: 0; padding: 0">
                                <ucGenericClientServerConnector:GenericClientServerConnector ID="GenericClientServerConnector1"
                                    runat="server" />
                                <blockquote id="boxDetail" class="detail">
                                    <h5 id="detailsTitle" runat="server">
                                    </h5>
                                    <ucGenericGrid:GenericGrid ID="gGridDetails" runat="server">
                                        <ucGenericContainer:GenericContainer ID="GenericContainerName" RowCssClass="inputtext"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblName" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericTextBox:GenericTextBox ID="cName" FieldName="Name" runat="server">
                                            </ucGenericTextBox:GenericTextBox>
                                        </ucGenericContainer:GenericContainer>
                                        <ucGenericContainer:GenericContainer ID="GenericContainerStartDate" RowCssClass="inputtext"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblStartDate" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericTextBox:GenericTextBox ID="cStartDate" FieldName="StartDateString" runat="server">
                                            </ucGenericTextBox:GenericTextBox>
                                        </ucGenericContainer:GenericContainer>
                                        <ucGenericContainer:GenericContainer ID="GenericContainerRetryDuration" RowCssClass="inputtext"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblRetryDuration" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericTextBox:GenericTextBox ID="cRetryDuration" FieldName="RetryDuration" runat="server">
                                            </ucGenericTextBox:GenericTextBox>
                                        </ucGenericContainer:GenericContainer>
                                        <ucGenericContainer:GenericContainer ID="GenericContainerRetryTimeout" RowCssClass="inputtext"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblRetryTimeout" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericTextBox:GenericTextBox ID="cRetryTimeout" FieldName="RetryTimeout" runat="server">
                                            </ucGenericTextBox:GenericTextBox>
                                        </ucGenericContainer:GenericContainer>
                                    </ucGenericGrid:GenericGrid>
                                    <h5 id="scheduleTitle" runat="server">
                                    </h5>
                                    <ucGenericGrid:GenericGrid ID="gGridSchedule" runat="server">
                                        <ucGenericContainer:GenericContainer ID="GenericContainer3" RowCssClass="inputarea"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblScheduleType" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericSelect:GenericSelect ID="cScheduleType" PropertyKey="Id" PropertyToDisplay="Name"
                                                runat="server">
                                            </ucGenericSelect:GenericSelect>
                                        </ucGenericContainer:GenericContainer>
                                        <ucGenericContainer:GenericContainer OutputID="true" ID="gcPeriodInt" RowCssClass="inputtext"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblPeriodInt" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericTextBox:GenericTextBox ID="cPeriodInt" FieldName="PeriodInt" runat="server">
                                            </ucGenericTextBox:GenericTextBox>
                                        </ucGenericContainer:GenericContainer>
                                        <ucGenericContainer:GenericContainer OutputID="true" ID="gcPeriodTime" RowCssClass="inputtext"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblPeriodTime" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericTextBox:GenericTextBox ID="cPeriodTime" FieldName="PeriodTime" runat="server">
                                            </ucGenericTextBox:GenericTextBox>
                                        </ucGenericContainer:GenericContainer>
                                    </ucGenericGrid:GenericGrid>
                                    <table>
                                        <tbody>
                                            <tr>
                                                <td id="panel_times" style="width: 50%">
                                                    <h6 runat="server" id="excecutionTimesTitle">
                                                    </h6>
                                                    <input type="text" name='cTimes' id='cTimes' style="display: none" />
                                                    <div id='times_add_panel'>
                                                        <input type="text" style="float: left; width: 40px;" name='times_add_input' id='times_add_input' />
                                                        <a id='times_add_btn' href='#'>
                                                            <img alt="Add" src="../media/img/Others/ActionSheduler/add_btn.gif" /></a>
                                                        <div style='clear: both;'>
                                                            <!--&nbsp;-->
                                                        </div>
                                                    </div>
                                                    <div id='times_message_panel'>
                                                        <div class='generalmessage message'>
                                                            <p runat="server" id="time_emptyMessage">
                                                                <!--&nbsp;-->
                                                            </p>
                                                        </div>
                                                    </div>
                                                    <div id='times_list_panel'>
                                                        <!--&nbsp;-->
                                                    </div>
                                                </td>
                                                <td id="panel_days" style="width: 50%">
                                                    <h6 runat="server" id="dayOfTheWeekTitle">
                                                    </h6>
                                                    <ucGenericGrid:GenericGrid ID="gGridDays" MainTableCssClass="optsgroup" IsNested="true"
                                                        IsList="false" runat="server">
                                                        <ucGenericContainer:GenericContainer ID="ContainerDays" TableCssClass="optsgroup"
                                                            runat="server">
                                                            <ucGenericText:GenericText ID="text11" HasHtmlLabel="true" Label="dati" runat="server">
                                                                <ucGenericContainer:GenericContainer ID="Container12" runat="server">
                                                                    <ucGenericCheckBox:GenericCheckBox FieldName="Id" ID="decDays" runat="server">
                                                                    </ucGenericCheckBox:GenericCheckBox>
                                                                    <ucGenericText:GenericText ID="text12" FieldName="Name" HasHtmlLabel="true" runat="server">
                                                                    </ucGenericText:GenericText>
                                                                </ucGenericContainer:GenericContainer>
                                                            </ucGenericText:GenericText>
                                                        </ucGenericContainer:GenericContainer>
                                                    </ucGenericGrid:GenericGrid>
                                                </td>
                                            </tr>
                                        </tbody>
                                    </table>
                                    <h5 id="actionTitle" runat="server">
                                    </h5>
                                    <ucGenericGrid:GenericGrid ID="gGridActions" runat="server">
                                        <ucGenericContainer:GenericContainer ID="GenericContainerActionType" RowCssClass="inputarea"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblActionType" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericSelect:GenericSelect ID="cActionType" PropertyKey="Id" PropertyToDisplay="Name"
                                                runat="server">
                                            </ucGenericSelect:GenericSelect>
                                        </ucGenericContainer:GenericContainer>
                                    </ucGenericGrid:GenericGrid>
                                    <ucGenericGrid:GenericGrid ID="gCommand" OutputID="true" runat="server">
                                        <ucGenericContainer:GenericContainer OutputID="true" ID="gcCommand" RowCssClass="inputtext"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblCommand" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericSelect:GenericSelect ID="decCommand" PropertyKey="Id" PropertyToDisplay="Name"
                                                HasHtmlLabel="false" runat="server">
                                            </ucGenericSelect:GenericSelect>
                                        </ucGenericContainer:GenericContainer>
                                    </ucGenericGrid:GenericGrid>
                                    <ucGenericGrid:GenericGrid ID="gArgs" OutputID="true" runat="server">
                                    </ucGenericGrid:GenericGrid>
                                    <ucGenericGrid:GenericGrid ID="gParamMain" OutputID="true" runat="server">
                                        <ucGenericContainer:GenericContainer ID="GenericContainerParamType" RowCssClass="inputarea"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblParamType" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericSelect:GenericSelect ID="cParamType" PropertyKey="Id" PropertyToDisplay="Name"
                                                runat="server">
                                            </ucGenericSelect:GenericSelect>
                                        </ucGenericContainer:GenericContainer>
                                    </ucGenericGrid:GenericGrid>
                                    <ucGenericGrid:GenericGrid ID="gParamFileName" OutputID="true" runat="server">
                                        <ucGenericContainer:GenericContainer ID="GenericContainerParFileName" RowCssClass="inputtext"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblParFileName" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericTextBox:GenericTextBox ID="cParamFileName" FieldName="paramFileName" runat="server">
                                            </ucGenericTextBox:GenericTextBox>
                                        </ucGenericContainer:GenericContainer>
                                    </ucGenericGrid:GenericGrid>
                                    <table id='gParameters'>
                                        <tr>
                                            <td>
                                                <h6 runat="server" id="parametersTitle">
                                                </h6>
                                                <input type="text" name='cParam' id='cParam' style="display: none" />
                                                <div id='parameters_add_panel'>
                                                    <div style="margin-top: 4px">
                                                        <label runat="server" id="param_new_label" class="new_param_input" />
                                                        <input type="text" style="float: left; width: 125px;" id='parameters_add_input_label' />
                                                        <label runat="server" id="param_case_sensitive" class="new_param_info" />
                                                        <div style='clear: both;'>
                                                            <!--&nbsp;-->
                                                        </div>
                                                    </div>
                                                    <div style="margin-top: 4px">
                                                        <label runat="server" id="param_new_value" class="new_param_input" />
                                                        <input type="text" style="float: left; width: 100px;" id='parameters_add_input_value' />
                                                        <a id='parameters_add_btn' href='#'>
                                                            <img alt="Add" src="../media/img/Others/ActionSheduler/add_btn.gif" /></a>
                                                        <div style='clear: both;'>
                                                            <!--&nbsp;-->
                                                        </div>
                                                    </div>
                                                </div>
                                                <div id='parameters_message_panel'>
                                                    <div class='generalmessage message'>
                                                        <p runat="server" id="param_emptyMessage">
                                                            <!--&nbsp;-->
                                                        </p>
                                                    </div>
                                                </div>
                                                <div id='parameters_list_panel'>
                                                    <!--&nbsp;-->
                                                </div>
                                            </td>
                                        </tr>
                                    </table>
                                </blockquote>
                            </td>
                            <td style="margin: 0; padding: 0">
                                <blockquote id="boxDetail_filter" class="detail">
                                    <h5 id="filtersTitle" runat="server">
                                    </h5>
                                    <ucGenericGrid:GenericGrid ID="gFilterLanguage" OutputID="true" runat="server">
                                        <ucGenericContainer:GenericContainer ID="GenericContainer3" RowCssClass="inputarea"
                                            runat="server">
                                            <ucGenericText:GenericText IsHeader="true" ID="lblFilterLanguage" runat="server">
                                            </ucGenericText:GenericText>
                                            <ucGenericSelect:GenericSelect ID="cCulture" PropertyKey="Id" PropertyToDisplay="Name"
                                                runat="server">
                                            </ucGenericSelect:GenericSelect>
                                        </ucGenericContainer:GenericContainer>
                                    </ucGenericGrid:GenericGrid>
                                    <div>
                                        <input runat="server" type="button" id="btnManageFilters" value="" />
                                    </div>
                                    <textarea name="cFilters" style="display: none" id="cFilters" cols="30" rows="80">&lt;empty/&gt;</textarea>
                                    <div id='treeFilterArea'>
                                        <!--&nbsp;-->
                                    </div>
                                </blockquote>
                            </td>
                        </tr>
                    </table>
                </td>
            </tr>
        </table>
    </div>
</asp:Content>
<asp:Content ID="Content4" runat="server" ContentPlaceHolderID="SubtabsArea">
    <ucSubtabMenuScheduler:SubtabMenuScheduler ID="SubtabMenuScheduler1" runat="server" />
</asp:Content>
<asp:Content ID="Content5" runat="server" ContentPlaceHolderID="PageTitleArea">
    <ucPageTitle:PageTitle ID="PageTitle1" runat="server">
    </ucPageTitle:PageTitle>
</asp:Content>
